mod classfile;
mod classstore;
mod bytecode;
mod jvm;
mod stackframe;
mod accessmasks;
mod constantpool;
mod heap_area;
mod iterators;

use std::fs::File;
//
use crate::accessmasks::FieldAccessFlag;
//use crate::stackframe::StackValue;
use crate::classfile::JavaClassFile;

fn main() {
    //println!("{:#?}", JavaClassFile::new(&mut File::open("java/lang/String.class").unwrap()).unwrap().fields.iter().filter(|f| ! (f.access_flags & FieldAccessFlag::Static)).collect::<Vec<_>>());

    let mut jvm = jvm::JVM::new();

    match jvm.entrypoint(
        &"Main".to_string(), 
        &"main".to_string(),
        &["Hello World"],
    ) {
        Ok(()) => (),
        Err(e) => println!("{:#?}", e),
    }

    match jvm.run() {
        Ok(()) => (),
        Err(e) => println!("{:#?}", e),
    };

    //println!("{:#?}", jvm.heap_area.static_area);
}
